diff -NrU2 vqcc-gtk-0.5/src/net.h vqcc-gtk-0.5.1-shaman5/src/net.h
--- vqcc-gtk-0.5/src/net.h	2004-12-17 05:04:29.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/net.h	2005-03-30 16:27:11.000000000 +0400
@@ -34,4 +34,6 @@
 #define PREFS_NET_IGNORE_MASS_MSG	"net/ignore_mass_msg"
 #define PREFS_NET_ENCODING		"net/encoding"
+#define PREFS_NET_SECONDARY_ENCODING		"net/secondary_encoding"
+#define PREFS_NET_CHARSET_CHOICE		"net/charset_choice"
 #define PREFS_NET_REPLY_INFO_REQ	"net/reply_info_req"
 #define PREFS_NET_MOTD			"net/motd"
@@ -56,3 +58,2 @@
 
 #endif /* #ifndef NET_H__ */
-
diff -NrU2 vqcc-gtk-0.5/src/user.c vqcc-gtk-0.5.1-shaman5/src/user.c
--- vqcc-gtk-0.5/src/user.c	2004-12-21 18:11:37.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/user.c	2005-06-28 20:50:38.000000000 +0400
@@ -36,4 +36,5 @@
 	gboolean is_active;	/* if user is active (emm.. watching) */
 	time_t last_time_active;/* this can be 0, if the user never changed his 'active' state */
+	unsigned long src_ip;	/* IP address of message source */
 	gboolean replied;	/* if the user has replied to refresh req */
 }
@@ -123,5 +124,5 @@
  */
 static gpointer
-add_user(const gchar * name, enum user_mode_enum mode)
+add_user(const gchar * name, enum user_mode_enum mode,const unsigned long * src_ip)
 {
 	user_info_t * u;
@@ -134,4 +135,5 @@
 	u = g_malloc(sizeof(user_info_t));
 	u->name = g_string_new(name);
+	u->src_ip = src_ip;
 	u->mode = mode;
 	u->is_active = TRUE;
@@ -347,5 +349,5 @@
 
 	case EVENT_NET_NEW_USER:
-		user = add_user(EVENT_V(p, 0), (enum user_mode_enum)EVENT_V(p, 1));
+		user = add_user(EVENT_V(p, 0), (enum user_mode_enum)EVENT_V(p, 1),EVENT_V(p, 3));
 		if(!EVENT_V(p, 2))
 			update_user_last_time_active(user);
@@ -456,4 +458,12 @@
 }
 
+const unsigned long *
+user_ip_of(gconstpointer u)
+{
+	//g_assert(u);
+	if(u==NULL) return 0;
+	return PUSER_INFO_T(u)->src_ip;
+}
+
 time_t
 user_last_time_active(gpointer user)
@@ -487,4 +497,2 @@
 	return name;
 }
-
-
diff -NrU2 vqcc-gtk-0.5/src/util.h vqcc-gtk-0.5.1-shaman5/src/util.h
--- vqcc-gtk-0.5/src/util.h	2004-12-24 06:16:04.000000000 +0300
+++ vqcc-gtk-0.5.1-shaman5/src/util.h	2005-04-12 02:30:53.000000000 +0400
@@ -23,4 +23,16 @@
 #define UTIL_H__
 
+enum user_list_column_enum {
+	COLUMN_ICON,
+	COLUMN_NICKNAME,
+	COLUMN_USER_PTR,
+	COLUMN_SELECTED,
+	COLUMN_NUM
+};
+
+
+
+//struct _ulist* Ulist;
+	
 /* list functions
  */
@@ -45,3 +57,2 @@
 
 #endif	/* #ifndef UTIL_H__ */
-
